function [newsamples w index] = resampling(particles,weights)

[n Ns] = size(particles);
newsamples = zeros(n,Ns);
index = zeros(1,Ns);
w = zeros(1,Ns);
c = zeros(1,Ns);
c(1) =  weights(1);
for ii = 2:Ns
    c(ii) = c(ii-1) + weights(ii);
end

i = 1;
u = zeros(1,Ns);
u(1) = rand/Ns;

for j = 1:Ns
    u(j) = u(1) + (j-1)/Ns;
    
    while (u(j)>c(i))
        i = i + 1;
    end
    
    newsamples(:,j) = particles(:,i);
    w(j) = 1/Ns;
    index(j) = i;
    
end

end

