function gVal = gCon(xpart)
% the constraints: g(x) <= C
% global T;

% y < p3*x^3 + p2*x^2 + p1*x + p0 + 2.5;
% y > p3*x^3 + p2*x^2 + p1*x + p0 - 2.5;
% sqrt(vx^2 + vy^2) < 12.5;


global C;

p3 = 5e-5; 
p2 = -0.004;
p1 = -0.2;
p0 = 125;


[n, N] = size(xpart);

% xdata = xpart(1,:);
% ydata = xpart(2,:);

up = xpart(2,:) - (p3*xpart(1,:).^3 + p2*xpart(1,:).^2 + p1*xpart(1,:) + p0);

low = -up;

vel = sqrt(xpart(3,:).^2 + xpart(4,:).^2);

gVal = [up; low; vel] - C*ones(1,N);
% 




% if nargout > 1
%     % partial differentiation
%     % Note: gGrad(i,j) = [d c(j) / d x(i)].
%     gGrad = [G'*x*(x'*x)^(-1/2), -G'*x*(x'*x)^(-1/2)];
% end

end